package hu.se.app02;

/**
 * Class under test.
 */
public class TaxApp {

	private TaxRates taxRates;

	public TaxApp(TaxRates taxRates) {
		this.taxRates = taxRates;
	}

	/**
	 * Given an amount, it calculates the amount including the tax using either the
	 * regular or the reduced tax rate (Mehrwertsteuer).
	 * 
	 * @param amount
	 *            the given amount
	 * @param reducedTaxRate
	 *            <code>true</code> if the reduced tax rate should be used, and
	 *            <code>false</code> if the regular tax rate should be used.
	 * @return the given amount including tax
	 */
	public double calculateAmountWithTax(double amount, boolean reducedTaxRate) {
		double taxRate;
		if (reducedTaxRate) {
			taxRate = this.taxRates.getReducedTaxRateForGermany();
		} else {
			taxRate = this.taxRates.getTaxRateForGermany();
		}
		double amountWithTax = amount * (1.00 + taxRate);
		// round amountWithTax to two decimal places (Nachkommastellen) and return it
		return Math.round(amountWithTax * 100.0) / 100.0;
	}

}
